{
Autor: Sawomir LGIEWCZYK
}
{
Prosty viewer do plikw spakowanych programem RAR
}
Unit RARV;

Interface

Uses
  Dos,Crt;

Const
  maxlin = 21;

Type
  T_MARK_HEAD = record
    HEAD_CRC   : word; {06152h}
    HEAD_TYPE  : byte; {072h}
    HEAD_FLAGS,
    HEAD_SIZE  : word;
  end;
  T_MAIN_HEAD = record
    HEAD_CRC   : word;
    HEAD_TYPE  : byte; {073h}
    HEAD_FLAGS,
    HEAD_SIZE  : word;
    RESERVED1  : word;
    RESERVED2  : LongInt;
  end;
  T_FILE_HEAD = record
    PACK_SIZE,
    UNP_SIZE   : LongInt;
    HOST_OS    : byte;
    FILE_CRC,
    FTIME      : LongInt;
    UNP_VER,
    METHOD     : byte;
    NAME_SIZE  : word;
    ATTR       : Longint;
  end;
  Ttest = array[0..65534]of byte;

Var
  test   : ^^Ttest;
  b      : byte;
  c      : char;
  f      : file;
  mark_h : ^^T_MARK_HEAD;
  pom_h  : ^^T_MARK_HEAD;
  main_h : ^^T_MAIN_HEAD;
  file_h : ^^T_FILE_HEAD;
  fpos,
  dodatek,
  rozpak,
  spak   : LongInt;
  data1,data2: DateTime;
  lines  : byte;
  err    : integer;
  komp,
  nazwa,
  idf    : string;
  koncz  : boolean;
  pomind : word;

procedure RARView(nazwaRAR : string);

Implementation

procedure koniec;
begin
  writeln('Nie mozna otworzyc pliku!!!');
  halt;
end;

Procedure WriteNazwaRAR(nazwaRAR:string);
Var
  dir    : DirStr;
  nazwa : NameStr;
  rozsz  : ExtStr;
begin
  FSplit(nazwaRAR,dir,nazwa,rozsz);
  Write(nazwa,rozsz);
end;

procedure WriteYear(rok : word);
begin
  rok:=rok mod 100;
  write(rok div 10, rok mod 10)
end;

procedure WriteDateTime(dataczas:longint);
var
  DT: DateTime;
begin
  UnpackTime(dataczas,DT);
  GotoXY(62,WhereY);
  WriteYear(DT.year);
  with DT do
  begin
    if month < 10 then
       write('/0',month)
    else
       write('/',month);
    if day < 10 then
       write('/0',day)
    else
       write('/',day);
    GotoXY(72,WhereY);
    if hour < 10 then
       write('0',hour)
    else
       write(hour);
    if min < 10 then
       write(':0',min)
    else
       write(':',min);
    if sec < 10 then
       write(':0',sec)
    else
       write(':',sec);
  end;
end;

procedure RARView(nazwaRAR : string);
begin
  new(Test);
  new(mark_h);
  new(main_h);
  new(file_h);
  new(pom_h);
  assign(f, nazwaRAR);
  {$I-}
  reset(f, 1);
  {$I+}
  idf:='       ';
  If IOResult  0 then
    koniec
  else
  repeat
    BlockRead(f,c,1,err);
    idf:=copy(idf,2,6)+c;
  until (idf=#$52#$61#$72#$21#$1a#$07#$00)and
        (err>0);
  if not(eof(f)) then
  begin
    rozpak := 0; spak := 0;
    lines:=0;
    writeln;
    write('Name                     Pack         Un');
    write('pack  Ratio  Method      Date      Time ');
    write('');
    write('');
    BlockRead(f,main_h^^,SizeOf(main_h^^),err);
    fpos:=FilePos(f);
    Seek(f,fpos+(main_h^^.HEAD_SIZE-err));{}
    koncz:=false;
    while (not(eof(f)))and(not(koncz)) do
    begin
      BlockRead(f,pom_h^^,SizeOf(pom_h^^),err);
      if err = 0 then koncz:=true;
      if pom_h^^.HEAD_TYPE=$74 then
      begin
        BlockRead(f,file_h^^,SizeOf(file_h^^),err);
        if err = 0 then koncz:=true;
        case file_h^^.METHOD of
          $30 : komp := 'Stored';
          $31 : komp := 'Fastest';
          $32 : komp := 'Fast';
          $33 : komp := 'Normal';
          $34 : komp := 'Good';
          $35 : komp := 'Best';
        end;
        nazwa[0]:=char(file_h^^.NAME_SIZE);
        fpos:=FilePos(f);
        BlockRead(f,nazwa[1],file_h^^.NAME_SIZE,err);
        fpos:=fpos+(file_h^^.PACK_SIZE+pom_h^^.HEAD_SIZE-
              SizeOf(pom_h^^)-SizeOf(file_h^^));
        seek(f,fpos);{}
        writeNazwaRAR(nazwa);
        GotoXY(15,WhereY);
        inc(rozpak,file_h^^.UNP_SIZE);
        inc(spak,file_h^^.PACK_SIZE);
        if (pom_h^^.HEAD_FLAGS and $e0 = $e0) then
          write('DIRECTORY':15,'':22)
        else
        begin
          with file_h^^ do
          begin
            if UNP_SIZE  0 then
            begin
              write(PACK_SIZE:15,UNP_SIZE:15);
              write(PACK_SIZE/UNP_SIZE*100:6:0);
              write('%');
            end
            else
            begin
              write(PACK_SIZE:15,UNP_SIZE:15);
              write(100:6,'%');
            end;
          end;
        end;
        write(komp:8);
        writedatetime(file_h^^.FTIME);
        writeln;
        inc(lines);
        if lines >= maxlin then
        begin
          readkey;
          lines:=0;
        end;
      end
      else
      begin
        if (pom_h^^.HEAD_FLAGS and $8000 0) then
          BlockRead(f,dodatek,4,err)
        else
          dodatek:=0;
        fpos:=FilePos(f)+pom_h^^.HEAD_SIZE-SizeOf(pom_h^^)+
              dodatek;
        Seek(f,fpos);{}
      end;
    end;
    write('');
    write('');
    WriteNazwaRAR(NazwaRAR);
    GotoXY(15,WhereY);
    writeln(spak:15,rozpak:15,spak/rozpak*100:6:0,'%');
  end;
  close(f);
  dispose(mark_h);
  dispose(main_h);
  dispose(file_h);
  dispose(pom_h);
  dispose(TESt);
end;

end.
